require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_SIGNAL_H)  && !defined (&__need_siginfo_t)  && !defined (&__need_sigevent_t)) {
    die("Never include this file directly.  Use <signal.h> instead");
}
if((!defined (&__have_sigval_t)  && (defined (&_SIGNAL_H) || defined (&__need_siginfo_t) || defined (&__need_sigevent_t)))) {
    eval 'sub __have_sigval_t () {1;}' unless defined(&__have_sigval_t);
}
if((!defined (&__have_siginfo_t)  && (defined (&_SIGNAL_H) || defined (&__need_siginfo_t)))) {
    eval 'sub __have_siginfo_t () {1;}' unless defined(&__have_siginfo_t);
    require 'bits/types.ph';
    eval 'sub si_int () { ($si_value->{sival_int});}' unless defined(&si_int);
    eval 'sub si_ptr () { ($si_value->{sival_ptr});}' unless defined(&si_ptr);
    eval 'sub si_trapno () { ($_reason->{_fault}->{_trapno});}' unless defined(&si_trapno);
    eval 'sub si_timerid () { ($_reason->{_timer}->{_timerid});}' unless defined(&si_timerid);
    eval 'sub si_overrun () { ($_reason->{_timer}->{_overrun});}' unless defined(&si_overrun);
    eval 'sub si_mqd () { ($_reason->{_mesgq}->{_mqd});}' unless defined(&si_mqd);
    eval 'sub si_band () { ($_reason->{_poll}->{_band});}' unless defined(&si_band);
    eval("sub SI_ASYNCIO () { 0x10004; }") unless defined(&SI_ASYNCIO);
    eval("sub SI_MESGQ () { 0x10005; }") unless defined(&SI_MESGQ);
    eval("sub SI_TIMER () { 0x10003; }") unless defined(&SI_TIMER);
    eval("sub SI_QUEUE () { 0x10002; }") unless defined(&SI_QUEUE);
    eval("sub SI_USER () { 0x10001; }") unless defined(&SI_USER);
    eval("sub SI_KERNEL () { 0x10006; }") unless defined(&SI_KERNEL);
    eval("sub SI_LWP () { 0x10007; }") unless defined(&SI_LWP);
    eval("sub SI_UNDEFINED () { 0; }") unless defined(&SI_UNDEFINED);
    eval("sub ILL_ILLOPC () { 1; }") unless defined(&ILL_ILLOPC);
    eval("sub ILL_ILLOPN () { 2; }") unless defined(&ILL_ILLOPN);
    eval("sub ILL_ILLADR () { 3; }") unless defined(&ILL_ILLADR);
    eval("sub ILL_ILLTRP () { 4; }") unless defined(&ILL_ILLTRP);
    eval("sub ILL_PRVOPC () { 5; }") unless defined(&ILL_PRVOPC);
    eval("sub ILL_PRVREG () { 6; }") unless defined(&ILL_PRVREG);
    eval("sub ILL_COPROC () { 7; }") unless defined(&ILL_COPROC);
    eval("sub ILL_BADSTK () { 8; }") unless defined(&ILL_BADSTK);
    eval("sub FPE_INTOVF () { 1; }") unless defined(&FPE_INTOVF);
    eval("sub FPE_INTDIV () { 2; }") unless defined(&FPE_INTDIV);
    eval("sub FPE_FLTDIV () { 3; }") unless defined(&FPE_FLTDIV);
    eval("sub FPE_FLTOVF () { 4; }") unless defined(&FPE_FLTOVF);
    eval("sub FPE_FLTUND () { 5; }") unless defined(&FPE_FLTUND);
    eval("sub FPE_FLTRES () { 6; }") unless defined(&FPE_FLTRES);
    eval("sub FPE_FLTINV () { 7; }") unless defined(&FPE_FLTINV);
    eval("sub FPE_FLTSUB () { 8; }") unless defined(&FPE_FLTSUB);
    eval("sub SEGV_MAPERR () { 1; }") unless defined(&SEGV_MAPERR);
    eval("sub SEGV_ACCERR () { 2; }") unless defined(&SEGV_ACCERR);
    eval("sub BUS_ADRALN () { 1; }") unless defined(&BUS_ADRALN);
    eval("sub BUS_ADRERR () { 2; }") unless defined(&BUS_ADRERR);
    eval("sub BUS_OBJERR () { 3; }") unless defined(&BUS_OBJERR);
    eval("sub TRAP_BRKPT () { 1; }") unless defined(&TRAP_BRKPT);
    eval("sub TRAP_TRACE () { 2; }") unless defined(&TRAP_TRACE);
    eval("sub CLD_EXITED () { 1; }") unless defined(&CLD_EXITED);
    eval("sub CLD_KILLED () { 2; }") unless defined(&CLD_KILLED);
    eval("sub CLD_DUMPED () { 3; }") unless defined(&CLD_DUMPED);
    eval("sub CLD_TRAPPED () { 4; }") unless defined(&CLD_TRAPPED);
    eval("sub CLD_STOPPED () { 5; }") unless defined(&CLD_STOPPED);
    eval("sub CLD_CONTINUED () { 6; }") unless defined(&CLD_CONTINUED);
    eval("sub POLL_IN () { 1; }") unless defined(&POLL_IN);
    eval("sub POLL_OUT () { 2; }") unless defined(&POLL_OUT);
    eval("sub POLL_MSG () { 3; }") unless defined(&POLL_MSG);
    eval("sub POLL_ERR () { 4; }") unless defined(&POLL_ERR);
    eval("sub POLL_PRI () { 5; }") unless defined(&POLL_PRI);
    eval("sub POLL_HUP () { 6; }") unless defined(&POLL_HUP);
    undef(&__need_siginfo_t) if defined(&__need_siginfo_t);
}
if((defined (&_SIGNAL_H) || defined (&__need_sigevent_t))  && !defined (&__have_sigevent_t)) {
    eval 'sub __have_sigevent_t () {1;}' unless defined(&__have_sigevent_t);
    require 'sys/_types.ph';
    unless(defined(&__have_pthread_attr_t)) {
	eval 'sub __have_pthread_attr_t () {1;}' unless defined(&__have_pthread_attr_t);
    }
    eval 'sub sigev_notify_kqueue () { &sigev_signo;}' unless defined(&sigev_notify_kqueue);
    eval 'sub sigev_notify_function () { ($_sigev_un->{_sigev_thread}->{_function});}' unless defined(&sigev_notify_function);
    eval 'sub sigev_notify_attributes () { ($_sigev_un->{_sigev_thread}->{_attribute});}' unless defined(&sigev_notify_attributes);
    eval 'sub sigev_notify_thread_id () { ($_sigev_un->{threadid});}' unless defined(&sigev_notify_thread_id);
    eval("sub SIGEV_SIGNAL () { 1; }") unless defined(&SIGEV_SIGNAL);
    eval("sub SIGEV_NONE () { 0; }") unless defined(&SIGEV_NONE);
    eval("sub SIGEV_THREAD () { 2; }") unless defined(&SIGEV_THREAD);
    eval("sub SIGEV_KEVENT () { 3; }") unless defined(&SIGEV_KEVENT);
    eval("sub SIGEV_THREAD_ID () { 4; }") unless defined(&SIGEV_THREAD_ID);
}
1;
