require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SIGSET_H_types)) {
    eval 'sub _SIGSET_H_types () {1;}' unless defined(&_SIGSET_H_types);
}
if(!defined (&_SIGSET_H_fns)  && defined (&_SIGNAL_H)) {
    eval 'sub _SIGSET_H_fns () {1;}' unless defined(&_SIGSET_H_fns);
    unless(defined(&_EXTERN_INLINE)) {
	eval 'sub _EXTERN_INLINE () { &__extern_inline;}' unless defined(&_EXTERN_INLINE);
    }
    eval 'sub __sigmask {
        my($sig) = @_;
	    eval q(( 1<< (($sig) - 1) % 32));
    }' unless defined(&__sigmask);
    eval 'sub __sigword {
        my($sig) = @_;
	    eval q(((($sig) - 1) >> 5));
    }' unless defined(&__sigword);
    if(defined (&__GNUC__)  && (defined(&__GNUC__) ? &__GNUC__ : undef) >= 2) {
	eval 'sub __sigemptyset {
	    my($set) = @_;
    	    eval q(( &__extension__ ({  &sigset_t * &__set = ($set);  ($__set->{__sigbits[0]}) = 0;  ($__set->{__sigbits[1]}) = 0;  ($__set->{__sigbits[2]}) = 0;  ($__set->{__sigbits[3]}) = 0; 0; })));
	}' unless defined(&__sigemptyset);
	eval 'sub __sigfillset {
	    my($set) = @_;
    	    eval q(( &__extension__ ({  &sigset_t * &__set = ($set);  ($__set->{__sigbits[0]}) = ~0;  ($__set->{__sigbits[1]}) = ~0;  ($__set->{__sigbits[2]}) = ~0;  ($__set->{__sigbits[3]}) = ~0; 0; })));
	}' unless defined(&__sigfillset);
	if(defined(&__USE_GNU)) {
	    eval 'sub __sigisemptyset {
	        my($set) = @_;
    		eval q(( &__extension__ ({  &const  &sigset_t * &__set = ($set);  ($__set->{__sigbits[0]}) == 0 &&  ($__set->{__sigbits[1]}) == 0 &&  ($__set->{__sigbits[2]}) == 0 &&  ($__set->{__sigbits[3]}) == 0; })));
	    }' unless defined(&__sigisemptyset);
	    eval 'sub __sigandset {
	        my($dest, $left, $right) = @_;
    		eval q(( &__extension__ ({  &sigset_t * &__dest = ($dest);  &const  &sigset_t * &__left = ($left);  &const  &sigset_t * &__right = ($right);  ($__dest->{__sigbits[0]}) =  ($__left->{__sigbits[0]}) &  ($__right->{__sigbits[0]});  ($__dest->{__sigbits[1]}) =  ($__left->{__sigbits[1]}) &  ($__right->{__sigbits[1]});  ($__dest->{__sigbits[2]}) =  ($__left->{__sigbits[2]}) &  ($__right->{__sigbits[2]});  ($__dest->{__sigbits[3]}) =  ($__left->{__sigbits[3]}) &  ($__right->{__sigbits[3]}); 0; })));
	    }' unless defined(&__sigandset);
	    eval 'sub __sigorset {
	        my($dest, $left, $right) = @_;
    		eval q(( &__extension__ ({  &sigset_t * &__dest = ($dest);  &const  &sigset_t * &__left = ($left);  &const  &sigset_t * &__right = ($right);  ($__dest->{__sigbits[0]}) =  ($__left->{__sigbits[0]}) |  ($__right->{__sigbits[0]});  ($__dest->{__sigbits[1]}) =  ($__left->{__sigbits[1]}) |  ($__right->{__sigbits[1]});  ($__dest->{__sigbits[2]}) =  ($__left->{__sigbits[2]}) |  ($__right->{__sigbits[2]});  ($__dest->{__sigbits[3]}) =  ($__left->{__sigbits[3]}) |  ($__right->{__sigbits[3]}); 0; })));
	    }' unless defined(&__sigorset);
	}
    }
    if(defined(&__USE_EXTERN_INLINES)) {
    }
}
1;
