require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_BITS_SYSMACROS_H)) {
    eval 'sub _BITS_SYSMACROS_H () {1;}' unless defined(&_BITS_SYSMACROS_H);
    unless(defined(&_SYS_SYSMACROS_H)) {
	die("Never include <bits/sysmacros.h> directly; use <sys/sysmacros.h> instead.");
    }
    eval 'sub __SYSMACROS_DECLARE_MAJOR {
        my($DECL_TEMPL) = @_;
	    eval q($DECL_TEMPL(\'unsigned int\',  &major, ( &__dev_t  &__dev)));
    }' unless defined(&__SYSMACROS_DECLARE_MAJOR);
    eval 'sub __SYSMACROS_DEFINE_MAJOR {
        my($DECL_TEMPL) = @_;
	    eval q( &__SYSMACROS_DECLARE_MAJOR ($DECL_TEMPL) {  &return (( &__dev & ( &__dev_t) 0xff00) >> 8); });
    }' unless defined(&__SYSMACROS_DEFINE_MAJOR);
    eval 'sub __SYSMACROS_DECLARE_MINOR {
        my($DECL_TEMPL) = @_;
	    eval q($DECL_TEMPL(\'unsigned int\',  &minor, ( &__dev_t  &__dev)));
    }' unless defined(&__SYSMACROS_DECLARE_MINOR);
    eval 'sub __SYSMACROS_DEFINE_MINOR {
        my($DECL_TEMPL) = @_;
	    eval q( &__SYSMACROS_DECLARE_MINOR ($DECL_TEMPL) {  &return ( &__dev & ( &__dev_t) 0xffff00ff); });
    }' unless defined(&__SYSMACROS_DEFINE_MINOR);
    eval 'sub __SYSMACROS_DECLARE_MAKEDEV {
        my($DECL_TEMPL) = @_;
	    eval q($DECL_TEMPL( &__dev_t,  &makedev, (\'unsigned int __major\', \'unsigned int __minor\')));
    }' unless defined(&__SYSMACROS_DECLARE_MAKEDEV);
    eval 'sub __SYSMACROS_DEFINE_MAKEDEV {
        my($DECL_TEMPL) = @_;
	    eval q( &__SYSMACROS_DECLARE_MAKEDEV ($DECL_TEMPL) {  &__dev_t  &__dev;  &__dev = ((( &__dev_t) ( &__major & 0xff)) << 8);  &__dev |= ((( &__dev_t) ( &__minor & 0xffff00ff)) << 0);  &return  &__dev; });
    }' unless defined(&__SYSMACROS_DEFINE_MAKEDEV);
}
1;
