require '_h2ph_pre.ph';

no warnings qw(redefine misc);

if(!defined (&_SIGNAL_H)  && !defined (&_SYS_UCONTEXT_H)) {
    die("Never use <bits/sigcontext.h> directly; include <signal.h> instead.");
}
unless(defined(&_BITS_SIGCONTEXT_H)) {
    eval 'sub _BITS_SIGCONTEXT_H () {1;}' unless defined(&_BITS_SIGCONTEXT_H);
    if(defined(&__i386__)) {
	eval 'sub sc_sp () { &sc_esp;}' unless defined(&sc_sp);
	eval 'sub sc_fp () { &sc_ebp;}' unless defined(&sc_fp);
	eval 'sub sc_pc () { &sc_eip;}' unless defined(&sc_pc);
	eval 'sub sc_ps () { &sc_efl;}' unless defined(&sc_ps);
	eval 'sub sc_eflags () { &sc_efl;}' unless defined(&sc_eflags);
	if(1) {
	    eval 'sub ILL_PRIVIN_FAULT () {1;}' unless defined(&ILL_PRIVIN_FAULT);
	    eval 'sub ILL_ALIGN_FAULT () {14;}' unless defined(&ILL_ALIGN_FAULT);
	    eval 'sub ILL_FPOP_FAULT () {24;}' unless defined(&ILL_FPOP_FAULT);
	    eval 'sub BUS_PAGE_FAULT () {12;}' unless defined(&BUS_PAGE_FAULT);
	    eval 'sub BUS_SEGNP_FAULT () {26;}' unless defined(&BUS_SEGNP_FAULT);
	    eval 'sub BUS_STK_FAULT () {27;}' unless defined(&BUS_STK_FAULT);
	    eval 'sub BUS_SEGM_FAULT () {29;}' unless defined(&BUS_SEGM_FAULT);
	}
    } else {
	eval 'sub sc_sp () { &sc_rsp;}' unless defined(&sc_sp);
	eval 'sub sc_fp () { &sc_rbp;}' unless defined(&sc_fp);
	eval 'sub sc_pc () { &sc_rip;}' unless defined(&sc_pc);
    }
}
1;
