require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&__BITS_SOCKET_H)) {
    eval 'sub __BITS_SOCKET_H () {1;}' unless defined(&__BITS_SOCKET_H);
    if(!defined (&_SYS_SOCKET_H)  && !defined (&_NETINET_IN_H)) {
	die("Never include <bits/socket.h> directly; use <sys/socket.h> instead.");
    }
    eval 'sub __need_size_t () {1;}' unless defined(&__need_size_t);
    eval 'sub __need_NULL () {1;}' unless defined(&__need_NULL);
    require 'stddef.ph';
    require 'limits.ph';
    require 'bits/types.ph';
    unless(defined(&__socklen_t_defined)) {
	eval 'sub __socklen_t_defined () {1;}' unless defined(&__socklen_t_defined);
    }
    eval("sub SOCK_STREAM () { 1; }") unless defined(&SOCK_STREAM);
    eval("sub SOCK_DGRAM () { 2; }") unless defined(&SOCK_DGRAM);
    eval("sub SOCK_RAW () { 3; }") unless defined(&SOCK_RAW);
    eval("sub SOCK_RDM () { 4; }") unless defined(&SOCK_RDM);
    eval("sub SOCK_SEQPACKET () { 5; }") unless defined(&SOCK_SEQPACKET);
    eval("sub SOCK_CLOEXEC () { 0x10000000; }") unless defined(&SOCK_CLOEXEC);
    eval("sub SOCK_NONBLOCK () { 0x20000000; }") unless defined(&SOCK_NONBLOCK);
    eval 'sub PF_UNSPEC () {0;}' unless defined(&PF_UNSPEC);
    eval 'sub PF_LOCAL () {1;}' unless defined(&PF_LOCAL);
    eval 'sub PF_UNIX () { &PF_LOCAL;}' unless defined(&PF_UNIX);
    eval 'sub PF_FILE () { &PF_LOCAL;}' unless defined(&PF_FILE);
    eval 'sub PF_INET () {2;}' unless defined(&PF_INET);
    eval 'sub PF_IMPLINK () {3;}' unless defined(&PF_IMPLINK);
    eval 'sub PF_PUP () {4;}' unless defined(&PF_PUP);
    eval 'sub PF_CHAOS () {5;}' unless defined(&PF_CHAOS);
    eval 'sub PF_NETBIOS () {6;}' unless defined(&PF_NETBIOS);
    eval 'sub PF_ISO () {7;}' unless defined(&PF_ISO);
    eval 'sub PF_OSI () { &PF_ISO;}' unless defined(&PF_OSI);
    eval 'sub PF_ECMA () {8;}' unless defined(&PF_ECMA);
    eval 'sub PF_DATAKIT () {9;}' unless defined(&PF_DATAKIT);
    eval 'sub PF_CCITT () {10;}' unless defined(&PF_CCITT);
    eval 'sub PF_SNA () {11;}' unless defined(&PF_SNA);
    eval 'sub PF_DECnet () {12;}' unless defined(&PF_DECnet);
    eval 'sub PF_DLI () {13;}' unless defined(&PF_DLI);
    eval 'sub PF_LAT () {14;}' unless defined(&PF_LAT);
    eval 'sub PF_HYLINK () {15;}' unless defined(&PF_HYLINK);
    eval 'sub PF_APPLETALK () {16;}' unless defined(&PF_APPLETALK);
    eval 'sub PF_ROUTE () {17;}' unless defined(&PF_ROUTE);
    eval 'sub PF_LINK () {18;}' unless defined(&PF_LINK);
    eval 'sub PF_XTP () {19;}' unless defined(&PF_XTP);
    eval 'sub PF_COIP () {20;}' unless defined(&PF_COIP);
    eval 'sub PF_CNT () {21;}' unless defined(&PF_CNT);
    eval 'sub PF_RTIP () {22;}' unless defined(&PF_RTIP);
    eval 'sub PF_IPX () {23;}' unless defined(&PF_IPX);
    eval 'sub PF_SIP () {24;}' unless defined(&PF_SIP);
    eval 'sub PF_PIP () {25;}' unless defined(&PF_PIP);
    eval 'sub PF_ISDN () {26;}' unless defined(&PF_ISDN);
    eval 'sub PF_KEY () {27;}' unless defined(&PF_KEY);
    eval 'sub PF_INET6 () {28;}' unless defined(&PF_INET6);
    eval 'sub PF_NATM () {29;}' unless defined(&PF_NATM);
    eval 'sub PF_ATM () {30;}' unless defined(&PF_ATM);
    eval 'sub PF_HDRCMPLT () {31;}' unless defined(&PF_HDRCMPLT);
    eval 'sub PF_NETGRAPH () {32;}' unless defined(&PF_NETGRAPH);
    eval 'sub PF_MAX () {33;}' unless defined(&PF_MAX);
    eval 'sub AF_UNSPEC () { &PF_UNSPEC;}' unless defined(&AF_UNSPEC);
    eval 'sub AF_LOCAL () { &PF_LOCAL;}' unless defined(&AF_LOCAL);
    eval 'sub AF_UNIX () { &PF_UNIX;}' unless defined(&AF_UNIX);
    eval 'sub AF_FILE () { &PF_FILE;}' unless defined(&AF_FILE);
    eval 'sub AF_INET () { &PF_INET;}' unless defined(&AF_INET);
    eval 'sub AF_IMPLINK () { &PF_IMPLINK;}' unless defined(&AF_IMPLINK);
    eval 'sub AF_PUP () { &PF_PUP;}' unless defined(&AF_PUP);
    eval 'sub AF_CHAOS () { &PF_CHAOS;}' unless defined(&AF_CHAOS);
    eval 'sub AF_NETBIOS () { &PF_NETBIOS;}' unless defined(&AF_NETBIOS);
    eval 'sub AF_ISO () { &PF_ISO;}' unless defined(&AF_ISO);
    eval 'sub AF_OSI () { &PF_OSI;}' unless defined(&AF_OSI);
    eval 'sub AF_ECMA () { &PF_ECMA;}' unless defined(&AF_ECMA);
    eval 'sub AF_DATAKIT () { &PF_DATAKIT;}' unless defined(&AF_DATAKIT);
    eval 'sub AF_CCITT () { &PF_CCITT;}' unless defined(&AF_CCITT);
    eval 'sub AF_SNA () { &PF_SNA;}' unless defined(&AF_SNA);
    eval 'sub AF_DECnet () { &PF_DECnet;}' unless defined(&AF_DECnet);
    eval 'sub AF_DLI () { &PF_DLI;}' unless defined(&AF_DLI);
    eval 'sub AF_LAT () { &PF_LAT;}' unless defined(&AF_LAT);
    eval 'sub AF_HYLINK () { &PF_HYLINK;}' unless defined(&AF_HYLINK);
    eval 'sub AF_APPLETALK () { &PF_APPLETALK;}' unless defined(&AF_APPLETALK);
    eval 'sub AF_ROUTE () { &PF_ROUTE;}' unless defined(&AF_ROUTE);
    eval 'sub AF_LINK () { &PF_LINK;}' unless defined(&AF_LINK);
    eval 'sub pseudo_AF_XTP () { &PF_XTP;}' unless defined(&pseudo_AF_XTP);
    eval 'sub AF_COIP () { &PF_COIP;}' unless defined(&AF_COIP);
    eval 'sub AF_CNT () { &PF_CNT;}' unless defined(&AF_CNT);
    eval 'sub pseudo_AF_RTIP () { &PF_RTIP;}' unless defined(&pseudo_AF_RTIP);
    eval 'sub AF_IPX () { &PF_IPX;}' unless defined(&AF_IPX);
    eval 'sub AF_SIP () { &PF_SIP;}' unless defined(&AF_SIP);
    eval 'sub pseudo_AF_PIP () { &PF_PIP;}' unless defined(&pseudo_AF_PIP);
    eval 'sub AF_ISDN () { &PF_ISDN;}' unless defined(&AF_ISDN);
    eval 'sub AF_E164 () { &AF_ISDN;}' unless defined(&AF_E164);
    eval 'sub pseudo_AF_KEY () { &PF_KEY;}' unless defined(&pseudo_AF_KEY);
    eval 'sub AF_INET6 () { &PF_INET6;}' unless defined(&AF_INET6);
    eval 'sub AF_NATM () { &PF_NATM;}' unless defined(&AF_NATM);
    eval 'sub AF_ATM () { &PF_ATM;}' unless defined(&AF_ATM);
    eval 'sub pseudo_AF_HDRCMPLT () { &PF_HDRCMPLT;}' unless defined(&pseudo_AF_HDRCMPLT);
    eval 'sub AF_NETGRAPH () { &PF_NETGRAPH;}' unless defined(&AF_NETGRAPH);
    eval 'sub AF_MAX () { &PF_MAX;}' unless defined(&AF_MAX);
    eval 'sub SOMAXCONN () {128;}' unless defined(&SOMAXCONN);
    require 'bits/sockaddr.ph';
    if((defined(&ULONG_MAX) ? &ULONG_MAX : undef) > 0xffffffff) {
	eval 'sub __ss_aligntype () { &__uint64_t;}' unless defined(&__ss_aligntype);
    } else {
	eval 'sub __ss_aligntype () { &__uint32_t;}' unless defined(&__ss_aligntype);
    }
    eval 'sub _SS_PADSIZE () {( &_SS_SIZE -  &__SOCKADDR_COMMON_SIZE - $sizeof{ &__ss_aligntype});}' unless defined(&_SS_PADSIZE);
    eval("sub MSG_OOB () { 0x01; }") unless defined(&MSG_OOB);
    eval("sub MSG_PEEK () { 0x02; }") unless defined(&MSG_PEEK);
    eval("sub MSG_DONTROUTE () { 0x04; }") unless defined(&MSG_DONTROUTE);
    eval("sub MSG_EOR () { 0x08; }") unless defined(&MSG_EOR);
    eval("sub MSG_TRUNC () { 0x10; }") unless defined(&MSG_TRUNC);
    eval("sub MSG_CTRUNC () { 0x20; }") unless defined(&MSG_CTRUNC);
    eval("sub MSG_WAITALL () { 0x40; }") unless defined(&MSG_WAITALL);
    eval("sub MSG_DONTWAIT () { 0x80; }") unless defined(&MSG_DONTWAIT);
    eval("sub MSG_EOF () { 0x100; }") unless defined(&MSG_EOF);
    eval("sub MSG_NOTIFICATION () { 0x2000; }") unless defined(&MSG_NOTIFICATION);
    eval("sub MSG_NBIO () { 0x4000; }") unless defined(&MSG_NBIO);
    eval("sub MSG_COMPAT () { 0x8000; }") unless defined(&MSG_COMPAT);
    eval("sub MSG_NOSIGNAL () { 0x20000; }") unless defined(&MSG_NOSIGNAL);
    if((defined(&__glibc_c99_flexarr_available) ? &__glibc_c99_flexarr_available : undef) ) {
    }
    eval 'sub CMSG_NXTHDR {
        my($mhdr, $cmsg) = @_;
	    eval q( &__cmsg_nxthdr ($mhdr, $cmsg));
    }' unless defined(&CMSG_NXTHDR);
    eval 'sub CMSG_FIRSTHDR {
        my($mhdr) = @_;
	    eval q(( ($mhdr)-> &msg_controllen >= $sizeof{\'struct cmsghdr\'} ?  ($mhdr)-> &msg_control :   &NULL));
    }' unless defined(&CMSG_FIRSTHDR);
    eval 'sub CMSG_ALIGN {
        my($len) = @_;
	    eval q(((($len) + $sizeof{\'size_t\'} - 1) &  ~($sizeof{\'size_t\'} - 1)));
    }' unless defined(&CMSG_ALIGN);
    eval 'sub CMSG_SPACE {
        my($len) = @_;
	    eval q(( &CMSG_ALIGN ($len) +  &CMSG_ALIGN ($sizeof{\'struct cmsghdr\'})));
    }' unless defined(&CMSG_SPACE);
    eval 'sub CMSG_LEN {
        my($len) = @_;
	    eval q(( &CMSG_ALIGN ($sizeof{\'struct cmsghdr\'}) + ($len)));
    }' unless defined(&CMSG_LEN);
    if((defined(&__glibc_c99_flexarr_available) ? &__glibc_c99_flexarr_available : undef) ) {
	eval 'sub CMSG_DATA {
	    my($cmsg) = @_;
    	    eval q((($cmsg)-> &__cmsg_data));
	}' unless defined(&CMSG_DATA);
    } else {
	eval 'sub CMSG_DATA {
	    my($cmsg) = @_;
    	    eval q(( ($cmsg) +  &CMSG_ALIGN($sizeof{\'struct cmsghdr\'})));
	}' unless defined(&CMSG_DATA);
    }
    if(defined(&__USE_EXTERN_INLINES)) {
	unless(defined(&_EXTERN_INLINE)) {
	    eval 'sub _EXTERN_INLINE () { &__extern_inline;}' unless defined(&_EXTERN_INLINE);
	}
    }
    eval("sub SCM_RIGHTS () { 0x01; }") unless defined(&SCM_RIGHTS);
    eval("sub SCM_TIMESTAMP () { 0x02; }") unless defined(&SCM_TIMESTAMP);
    eval("sub SCM_CREDS () { 0x03; }") unless defined(&SCM_CREDS);
    eval 'sub CMGROUP_MAX () {16;}' unless defined(&CMGROUP_MAX);
    eval 'sub SOL_SOCKET () {0xffff;}' unless defined(&SOL_SOCKET);
    eval("sub SO_DEBUG () { 0x0001; }") unless defined(&SO_DEBUG);
    eval("sub SO_ACCEPTCONN () { 0x0002; }") unless defined(&SO_ACCEPTCONN);
    eval("sub SO_REUSEADDR () { 0x0004; }") unless defined(&SO_REUSEADDR);
    eval("sub SO_KEEPALIVE () { 0x0008; }") unless defined(&SO_KEEPALIVE);
    eval("sub SO_DONTROUTE () { 0x0010; }") unless defined(&SO_DONTROUTE);
    eval("sub SO_BROADCAST () { 0x0020; }") unless defined(&SO_BROADCAST);
    eval("sub SO_USELOOPBACK () { 0x0040; }") unless defined(&SO_USELOOPBACK);
    eval("sub SO_LINGER () { 0x0080; }") unless defined(&SO_LINGER);
    eval("sub SO_OOBINLINE () { 0x0100; }") unless defined(&SO_OOBINLINE);
    eval("sub SO_REUSEPORT () { 0x0200; }") unless defined(&SO_REUSEPORT);
    eval("sub SO_TIMESTAMP () { 0x0400; }") unless defined(&SO_TIMESTAMP);
    eval("sub SO_SNDBUF () { 0x1001; }") unless defined(&SO_SNDBUF);
    eval("sub SO_RCVBUF () { 0x1002; }") unless defined(&SO_RCVBUF);
    eval("sub SO_SNDLOWAT () { 0x1003; }") unless defined(&SO_SNDLOWAT);
    eval("sub SO_RCVLOWAT () { 0x1004; }") unless defined(&SO_RCVLOWAT);
    eval("sub SO_SNDTIMEO () { 0x1005; }") unless defined(&SO_SNDTIMEO);
    eval("sub SO_RCVTIMEO () { 0x1006; }") unless defined(&SO_RCVTIMEO);
    eval("sub SO_ERROR () { 0x1007; }") unless defined(&SO_ERROR);
    eval("sub SO_STYLE () { 0x1008; }") unless defined(&SO_STYLE);
    eval("sub SO_TYPE () { SO_STYLE; }") unless defined(&SO_TYPE);
    eval("sub SO_LABEL () { 0x1009; }") unless defined(&SO_LABEL);
    eval("sub SO_PEERLABEL () { 0x1010; }") unless defined(&SO_PEERLABEL);
    eval("sub SO_LISTENQLIMIT () { 0x1011; }") unless defined(&SO_LISTENQLIMIT);
    eval("sub SO_LISTENQLEN () { 0x1012; }") unless defined(&SO_LISTENQLEN);
    eval("sub SO_LISTENINCQLEN () { 0x1013; }") unless defined(&SO_LISTENINCQLEN);
    eval("sub SO_SETFIB () { 0x1014; }") unless defined(&SO_SETFIB);
    eval("sub SO_USER_COOKIE () { 0x1015; }") unless defined(&SO_USER_COOKIE);
    eval("sub SO_PROTOCOL () { 0x1016; }") unless defined(&SO_PROTOCOL);
    eval("sub SO_PROTOTYPE () { SO_PROTOCOL; }") unless defined(&SO_PROTOTYPE);
    eval 'sub LOCAL_PEERCRED () {0x1;}' unless defined(&LOCAL_PEERCRED);
    eval 'sub LOCAL_CREDS () {0x2;}' unless defined(&LOCAL_CREDS);
    eval 'sub LOCAL_CONNWAIT () {0x4;}' unless defined(&LOCAL_CONNWAIT);
    eval 'sub INADDR_ALLRPTS_GROUP () {( &uint32_t)0xe0000016;}' unless defined(&INADDR_ALLRPTS_GROUP);
    eval 'sub INADDR_CARP_GROUP () {( &uint32_t)0xe0000012;}' unless defined(&INADDR_CARP_GROUP);
    eval 'sub INADDR_PFSYNC_GROUP () {( &uint32_t)0xe00000f0;}' unless defined(&INADDR_PFSYNC_GROUP);
    eval 'sub INADDR_ALLMDNS_GROUP () {( &uint32_t)0xe00000fb;}' unless defined(&INADDR_ALLMDNS_GROUP);
    if(defined(&__USE_MISC)) {
    }
}
1;
